10 '   UDMS Version 5.30 (July 1987)
15 '   Copyright 1983, 1986, 1987 by
16 '   United Nations Centre for Human Settlements, Nairobi, Kenya
18 '
19 '   Introduction, Main Menu, Disk Manual and Common Routines
99 '
100 '              PROGRAM START
101 '
110 RESET:CLEAR:DEFINT A-U:ON ERROR GOTO 9010          		'initialize
120 GOSUB 290:SCREEN 0:WIDTH 80:GOTO 1010                      	'graphics check
198 '
199 '
200 '              SUBROUTINES
201 '
204 'Beep and erase 25th line
205 SOUND 125,2:LOCATE 25,1:PRINT SPC(79):LOCATE 25,1:RETURN
208 '
209 'Screen header
210 CLS:PRINT MN$:LOCATE 1,11:PRINT TITLE$:LOCATE 1,74:PRINT "UDMS/5"
211 PRINT STRING$(80,45):RETURN
218 '
219 'Menu response
220 GOSUB 205:PRINT "Choose desired option (RETURN for Main Menu):";
221 A$="":WHILE A$="":A$=INKEY$:WEND:IF A$=CHR$(13) THEN GOTO 310
222 OPTNO=VAL(A$):IF OPTNO>N OR OPTNO<0 THEN GOTO 220 ELSE RETURN
228 '
229 'PrtSc routine
230 PROMPT$="Do you want to print the screen -- Y/N?":GOSUB 250
231 IF A$=CHR$(13) OR INSTR("Yy",A$)=0 THEN RETURN
232 DEF SEG=0
233 TEST1=INP(PEEK(1032)+256*PEEK(1033)+1) AND 16              'LPT1 test
234 TEST2=INP(PEEK(1024)+256*PEEK(1025)+5) AND 32              'COM1 test
235 TEST3=INP(PEEK(1026)+256*PEEK(1027)+5) AND 32:DEF SEG      'LPT2 test
236 IF TEST1=16 OR TEST2=32 OR TEST3=32 THEN GOTO 238
237 PROMPT$="Is your printer ready?  Press any key to proceed.":GOSUB 250
238 GOSUB 205:CALL INTERRUPT 5
239 A$=RIGHT$(DATE$,2)+LEFT$(DATE$,2)+MID$(DATE$,4,2)+"/"+LEFT$(TIME$,5)
240 LPRINT TAB(67);A$:LPRINT:LPRINT
243 '
244 'Any key to proceed
245 GOSUB 205:PRINT "Press any key to proceed.";:GOTO 251
246 '
249 'Prompt for single-key response
250 GOSUB 205:PRINT PROMPT$;
251 A$=INKEY$:IF A$="" THEN GOTO 251 ELSE RETURN
288 '
289 'Graphics monitor check
290 DEF SEG=0
291 IF PEEK(1123)+256*PEEK(1124)=948 THEN MONITOR=0 ELSE MONITOR=1
292 DEF SEG:RETURN
293 '
294 'Line clearing routine
295 LOCATE TOP,1:FOR L=TOP TO BOT:PRINT SPC(79):NEXT L:LOCATE TOP,1:RETURN
298 '
299 '
300 '              MAIN MENU
301 '
310 MN$="":TITLE$="URBAN DATA MANAGEMENT SOFTWARE (UDMS)":GOSUB 210:LOCATE 5,1
311 PRINT "          1   GEOBASE FORMATION":PRINT
312 PRINT "          2   SPATIAL SEARCH":PRINT
313 PRINT "          3   LINEAR REGRESSION & GRAVITY MODEL":PRINT
314 PRINT "          4   OPTIMUM LOCATION & SHORTEST PATH":PRINT
315 PRINT "          5   MAPPING":PRINT
317 PRINT "          6   UDMS DISK MANUAL":PRINT
320 PRINT "          0   EXIT TO DOS"
330 PROMPT$="Choose desired option:  ":GOSUB 250
332 IF INSTR("0123456",A$)=0 THEN GOTO 330 ELSE OPTNO=VAL(A$)
334 IF OPTNO=0 THEN GOTO 380
336 IF OPTNO=5 AND MONITOR=0_
    THEN PROMPT$="You need graphics for the mapping option. Press any key.":GOSUB 250:GOSUB 330
356 ON OPTNO GOTO 10000,20000,30000,40000,50000,610
358 '
360 '
377 '               EXIT MESSAGE & END
378 '
380 CLS:LOCATE 7,1
381 PRINT "              ͻ
382 PRINT "                                                               
383 PRINT "                Thank you for using UDMS.  Please report any   
384 PRINT "                          errors or suggestions to:            
385 PRINT "                                                               
386 PRINT "                 UNCHS (Habitat), Box 30030, Nairobi, Kenya.   
387 PRINT "                                                               
388 PRINT "              Ķ
389 PRINT "                                                               
390 PRINT "                          The time now is ";LEFT$(TIME$,5);".";
391 PRINT "               
392 PRINT "                                                               
393 PRINT "              ͼ
395 PRINT:PRINT:PRINT:PRINT:IF MONITOR=1 THEN COLOR 7,0,0
396 END
398 '
399 '
600 '              DISK MANUAL CALL ROUTINE
601 '
610 IF MANFLAG=1 THEN GOTO 650 ELSE MANFLAG=1
620 N=10:DIM MAN$(N*25):GOSUB 205:PRINT "Loading Disk Manual . . . .";
630 OPEN "UDMS.MAN" AS #1 LEN=79:FIELD #1,79 AS A$
640 FOR I=1 TO N*25:GET #1,I:MAN$(I)=A$:NEXT I:CLOSE
650 MN$="6.0":TITLE$="UDMS DISK MANUAL":IF MONITOR=1 THEN COLOR 15,6,6
660 GOSUB 210:LOCATE 5,1                             'white on magenta
661 PRINT "Page     1   Introduction to UDMS
662 PRINT "         2   UDMS File Structure
663 PRINT "         3   UDMS Program Operation
664 PRINT "         4   Coordinate Files for Map and Region
665 PRINT "         5   Variable and Points Files
666 PRINT "         6   Network Files
667 PRINT "         7   For Further Information
668 PRINT "         8   (Reserved for Future Use)
669 PRINT "         9   Minimum System Requirements
670 PRINT "         0   Programmers' Notes
680 GOSUB 220:IF OPTNO=0 THEN OPTNO=10
699 '
700 CLS:K=(OPTNO-1)*25+1:FOR I=K TO K+21                    'page display
710 LOCATE I-(OPTNO-1)*25,1:PRINT MAN$(I);:NEXT I:GOSUB 230:GOTO 650
798 '
799 '
800 '              DEFAULT DRIVE/FILENAME IDENTIFICATION
801 '
810 PROMPT$="Enter the drive where your data files are located: "
820 GOSUB 250:DRIVE$=A$+":"
830 GOSUB 205:INPUT"Enter the default path/filename (no extension): ";DEFAULT$
840 IF INSTR(DEFAULT$,".")>0 THEN GOTO 830
850 FILE$=DRIVE$+DEFAULT$:RETURN
997 '
998 '
999 '
1000 '             MAIN PROGRAM
1001 '
1010 IF MONITOR=1 THEN COLOR 15,1,1        			'white on blue
1030 CLS:DIM BL(33):M$=STRING$(2,219)                      	'initialize logo
1040 FOR I=1 TO 33:READ BL(I):NEXT I
1050 FOR I=0 TO 30 STEP 3:LOCATE I/3+3,BL(I+1)                 	'upper circle
1060 PRINT STRING$(BL(I+2),M$);SPC(BL(I+3));STRING$(BL(I+2),M$):NEXT I
1070 FOR I=30 TO 1 STEP -3:LOCATE 24-I/3,BL(I-2)               	'lower circle
1080 PRINT STRING$(BL(I-1),M$);SPC(BL(I));STRING$(BL(I-1),M$):NEXT I
1099 '
1100 FOR I=1 TO 13                                             	'triangle sides
1110 LOCATE I+2,41-I:PRINT M$;:LOCATE I+2,41+I:PRINT M$;:NEXT I
1120 FOR I=27 TO 55:LOCATE 16,I:PRINT M$;:NEXT I               	'triangle base
1130 FOR I=9 TO 23:LOCATE I,41:PRINT M$;:NEXT I                	'figure body
1140 LOCATE 9,42:PRINT M$;                                     	'figure head
1150 FOR I=0 TO 11                                             	'figure arms
1160 LOCATE 13-INT(I/2),41-I:PRINT M$;:LOCATE 13-INT(I/2),41+I:PRINT M$;:NEXT I
1170 LOCATE 25,15:PRINT "UNITED NATIONS CENTRE FOR HUMAN SETTLEMENTS (HABITAT)";
1180 I=VAL(RIGHT$(TIME$,1))+5:WHILE RIGHT$(STR$(I),1)<>RIGHT$(TIME$,1):WEND
1199 '
1200 CLS:LOCATE 5,1
1210 PRINT "                                  Ŀ
1211 PRINT "                                    
1212 PRINT "                                    
1213 PRINT "                   Ŀ  Ŀ    Ŀ Ŀ
1214 PRINT "                          Ŀ     Ŀ Ŀ    
1215 PRINT "                                        Ŀ
1216 PRINT "                                      Ŀ 
1217 PRINT "                                   
1218 PRINT "                        
1220 PRINT
1230 PRINT "                   URBAN      DATA      MANAGEMENT   SOFTWARE
1240 LOCATE 19,33:PRINT "- VERSION  5.3 -
1250 LOCATE 22,16:PRINT "Distributed subject to the UDMS Licence Agreement"
1260 I=VAL(RIGHT$(TIME$,1))+5:WHILE RIGHT$(STR$(I),1)<>RIGHT$(TIME$,1):WEND
1299 '
1300 CLS:PRINT
1310 PRINT "              ͻ
1320 PRINT "                                                                
1330 PRINT "                  URBAN DATA MANAGEMENT SOFTWARE -- VERSION 5   
1340 PRINT "                                                                
1350 PRINT "                       Copyright 1983, 1986, 1987 by the        
1360 PRINT "                                                                
1370 PRINT "                 UNITED NATIONS CENTRE  FOR HUMAN SETTLEMENTS   
1380 PRINT "                                   (HABITAT)                    
1390 PRINT "                                                                
1400 PRINT "                           Box 30030, Nairobi, Kenya            
1410 PRINT "                                                                
1415 PRINT "              Ķ
1420 PRINT "                                                                
1430 PRINT "                Original program by Vince Robinson & Wanna Chin 
1440 PRINT "                                                                
1450 PRINT "                   UDMS/5 completely revised & rewritten by:    
1455 PRINT "                                                                
1460 PRINT "                              Timothy Cartwright                
1470 PRINT "                               Herbert Seaforth                 
1475 PRINT "                              Mark Richard Brown                
1480 PRINT "                                                                
1485 PRINT "              ͼ
1490 LOCATE 25,28:PRINT "Press any key to proceed.";
1495 WHILE INKEY$="":WEND
1499 '
1500 CLS:GOSUB 205:LOCATE 4,1
1520 PRINT "              ͻ
1522 PRINT "                                                                
1524 PRINT "                                  ATTENTION!                    
1526 PRINT "                                                                
1528 PRINT "                UDMS automatically stamps its printouts with    
1530 PRINT "                  the current date and time on your system.     
1532 PRINT "                                                                
1534 PRINT "                The date is ";DATE$;" and the time is ";
1536 PRINT LEFT$(TIME$,5);".   
1538 PRINT "                                                                
1540 PRINT "                Furthermore, you have to have run the program   
1542 PRINT "                   GRAPHICS from DOS to get any printouts.      
1544 PRINT "                                                                
1546 PRINT "                  Press <Y> if you want to exit now to reset    
1548 PRINT "                    the date or time or to run GRAPHICS.        
1550 PRINT "                                                                
1552 PRINT "                       Press any other key to proceed.          
1554 PRINT "                                                                
1556 PRINT "              ͼ
1560 LOCATE 25,1:A$=INKEY$:IF A$="" THEN GOTO 1560
1570 IF INSTR("Yy",A$)>0 THEN COLOR 7,0,0:END
1599 '
1600 GRT$=LEFT$(TIME$,2):IF VAL(GRT$)<12 THEN GRT$="GOOD MORNING":GOTO 1700
1610 IF VAL(GRT$)>17 THEN GRT$="GOOD EVENING" ELSE GRT$="GOOD AFTERNOON"
1699 '
1700 CLS:LOCATE 5,15:PRINT GRT$;" AND WELCOME TO UDMS . . . .":LOCATE 10,1
1710 PRINT "Urban Data Management System from UNCHS (Habitat) is a polygon-based
1720 PRINT "geographic information system.  UDMS can store, analyze and display
1730 PRINT "data related to points, areas and networks located on any surface.
1740 PRINT:PRINT
1750 PRINT "UDMS is very easy to use.  Just follow the four simple steps shown
1760 PRINT "on the next screen."
1770 GOSUB 245
1799 '
1800 CLS:LOCATE 1,10:PRINT "FOUR SIMPLE STEPS TO USING UDMS":PRINT:PRINT
1810 PRINT "STEP 1   Using a word processor or spreadsheet, create a plain ASCII
1812 PRINT "         data file (*.DAT) containing the coordinates of your map.
1814 PRINT
1820 PRINT "STEP 2   Run UDMS and select Menu option 1.1 to convert your *.DAT
1822 PRINT "         file into the form that UDMS requires.
1824 PRINT
1830 PRINT "STEP 3   Select any other options you require from Menu option 1,
1832 PRINT "         such as 1.2 to define regions, 1.3 to define variables,
1834 PRINT "         1.4 to define points, or 1.5 to define networks.
1836 PRINT
1840 PRINT "STEP 4   Run other Menu options as you like -- for mapping, calcu-
1842 PRINT "         lating distances, searching for points, locating facilities
1844 PRINT "         and so on.
1846 PRINT:PRINT
1850 PRINT "To help you get started, your program disk has a set of data files
1860 PRINT "called HABITAT.*. Just enter HABITAT whenever you are asked for a
1870 PRINT "filename.  For more details select Disk Manual on the next screen.
1880 GOSUB 245:GOTO 310
1899 '
1900 DATA 33,8,0,29,7,9,26,5,19,24,5,23,22,5,27,21,4,31
1910 DATA 20,4,33,20,3,35,19,4,35,19,3,37,19,3,37
8997 '
8998 '
8999 '
9000 '              DEFAULT ERROR ROUTINE
9001 '
9010 CLS:LOCATE 7,20:PRINT "A TECHNICAL PROBLEM . . . .":LOCATE 10,1
9020 PRINT "It appears that there is some unanticipated difficulty in running
9030 PRINT "UDMS on your system.  There are various sources of possible diffi-
9040 PRINT "culty related to both the hardware (ROM, RAM, video monitor/adapter,
9050 PRINT "printer, etc.) and the software (particularly the operating system).
9060 PRINT "ERROR NUMBER ";ERR "IN LINE";ERL
9070 PRINT "For further information, send complete details of your system to:
9080 PRINT:PRINT "      United Nations Centre for Human Settlements (UNCHS)
9090 PRINT "                  Box 30030, Nairobi, Kenya":GOTO 395
20000 $INCLUDE "UDMS2.BAS"
30000 $INCLUDE "UDMS3.BAS"
40000 $INCLUDE "UDMS4.BAS"
50000 $INCLUDE "UDMS5.BAS"
10000 $SEGMENT
10001 $INCLUDE "UDMS1.BAS"

